;
; seticon header file
;
!ifndef LR_LOADFROMFILE
  !define LR_LOADFROMFILE     0x0010
!endif

!ifndef WM_SETICON
  !define WM_SETICON          0x80
!endif

!ifndef WM_ENABLE
  !define WM_ENABLE           0xA
!endif

!ifndef SHCNE_ASSOCCHANGED
  !define SHCNE_ASSOCCHANGED  0x08000000
!endif

!ifndef SHCNF_IDLIST
  !define SHCNF_IDLIST        0
!endif

!ifndef WM_SETREDRAW
  !define WM_SETREDRAW        0xB
!endif

!ifndef WM_NCPAINT
  !define WM_NCPAINT          0x85
!endif

!ifndef RDW_INVALIDATE
  !define RDW_INVALIDATE      0x1
!endif

!ifndef RDW_UPDATENOW
  !define RDW_UPDATENOW       0x100
!endif

!ifndef WM_CANCELMODE
  !define WM_CANCELMODE       0x1F
!endif

!ifndef WS_EX_TOOLWINDOW
   !define WS_EX_TOOLWINDOW   0x00000080
!endif

!ifndef DS_MODALFRAME
  !define DS_MODALFRAME       0x00000080
!endif

!ifndef WS_DLGFRAME
   !define WS_DLGFRAME        0x00400000
!endif

!ifndef WS_EX_DLGMODALFRAME
  !define WS_EX_DLGMODALFRAME 0x00000001
!endif

!ifndef WS_EX_WINDOWEDGE
  !define WS_EX_WINDOWEDGE    0x00000100
!endif

!ifndef WS_EX_LEFT
  !define WS_EX_LEFT          0x00000000
!endif

!ifndef WS_EX_LTRREADING
  !define WS_EX_LTRREADING    0x00000000
!endif

!ifndef WS_EX_RIGHTSCROLLBAR
  !define WS_EX_RIGHTSCROLLBAR 0x00000000
!endif

;!ifndef WS_EX_TOPMOST
;  !define WS_EX_TOPMOST       0x00000008
;!endif

!ifndef WS_POPUP
  !define WS_POPUP            0x80000000
!endif

!ifndef WS_POPUPWINDOW
  !define WS_POPUPWINDOW      0x80880000
!endif

!ifndef WS_SYSMENU
  !define WS_SYSMENU          0x00080000
!endif

!ifndef WS_CAPTION
  !define WS_CAPTION          0x00C00000
!endif

!ifndef WS_VISIBLE
  !define WS_VISIBLE          0x10000000
!endif

!ifndef WS_BORDER
  !define WS_BORDER           0x00800000
!endif

!ifndef WS_OVERLAPPED
  !define WS_OVERLAPPED       0x00000000
!endif

!ifndef WS_CLIPSIBLINGS
  !define WS_CLIPSIBLINGS     0x04000000
!endif

!ifndef WS_MINIMIZEBOX
  !define WS_MINIMIZEBOX      0x00020000
!endif

!ifndef SW_SHOW
  !define SW_SHOW        5
!endif

!ifndef SW_HIDE
  !define SW_HIDE        0
!endif

!ifndef SW_SHOWMINIMIZED
  !define SW_SHOWMINIMIZED 2
!endif

!ifndef SW_SHOWNA
  !define SW_SHOWNA      8
!endif

!ifndef WM_SHOWWINDOW
  !define WM_SHOWWINDOW 0x18
!endif

!ifndef SW_SHOWNORMAL
  !define SW_SHOWNORMAL  1
!endif

!ifndef WM_ACTIVATE
  !define WM_ACTIVATE    6
!endif

!ifndef WA_ACTIVE
  !define WA_ACTIVE      1
!endif

!ifndef WA_CLICKACTIVE
  !define WA_CLICKACTIVE 0x2
!endif

!ifndef GWL_EXSTYLE
   !define GWL_EXSTYLE        -20
!endif

!ifndef GWL_STYLE
  !define GWL_STYLE           -16
!endif

!ifndef IMAGE_ICON
  !define IMAGE_ICON          1
!endif

!ifndef ICON_SMALL
  !define ICON_SMALL          0
!endif

!ifndef ICON_BIG
  !define ICON_BIG            1
!endif

!ifndef sysLoadImage
  !define sysLoadImage        "user32::LoadImageA(i, t, i, i, i, i) i"
!endif

!ifndef sysSetWindowLong
   !define sysSetWindowLong   "user32::SetWindowLongA(i, i, i) i"
!endif

!ifndef sysRedrawWindow
  !define sysRedrawWindow     "user32::RedrawWindow(i, i, i, i) i"
!endif

!ifndef sysShowWindow
  !define sysShowWindow       "user32::ShowWindow(i, i) i"
!endif

!ifndef sysSHChangeNotify
  !define sysSHChangeNotify   "shell32::SHChangeNotify(i, i, i, i)"
!endif

!ifndef sysUpdateWindow
  !define sysUpdateWindow     "user32::UpdateWindow(i) i"
!endif

!ifndef sysSetFocus
  !define sysSetFocus         "user32::SetFocus(i) i"
!endif

!macro DisplayIcon H_WND IMG_NAME
;  Push $0
  Push $6
  Push $7
  StrCmp ${IMG_NAME} 'NULL' empty
;  StrCmp ${IMG_NAME} 'UPDATE' updatewindow
    System::Call '${sysLoadImage} (0, s, ${IMAGE_ICON}, 0, 0, ${LR_LOADFROMFILE}) .r6' "${IMG_NAME}"
    SendMessage ${H_WND} ${WM_SETICON} "${ICON_SMALL}" "$6" "$6"
    GoTo end
  empty:
    ;
    ; creates a tool window to avoid an icon and repaint client area
    ;
;    Push $8
;    System::Call '${sysSetWindowLong} (${H_WND}, ${GWL_STYLE}, ${WS_CAPTION}|${WS_DLGFRAME}|${WS_SYSMENU}|${WS_POPUP}|${WS_BORDER}) .r7'
;    System::Call '${sysSetWindowLong} (${H_WND}, ${GWL_EXSTYLE}, ${WS_EX_DLGMODALFRAME}|${WS_EX_TOOLWINDOW}) .r6'
    ;
    ; make sure the window is displayed
    ;
;    System::Call '${sysShowWindow} (${H_WND}, ${SW_SHOW}) .r8'
    ;
    ; make sure the frame is repainted too
    ;
;    SendMessage ${H_WND} ${WM_NCPAINT} "1" "" $8
;    GoTo end
;  updatewindow:
    System::Call '${sysSetWindowLong} (${H_WND}, ${GWL_EXSTYLE}, ${WS_EX_TOOLWINDOW}|${WS_EX_DLGMODALFRAME}) .r6'
    SendMessage ${H_WND} ${WM_NCPAINT} "1" "" $6
  end:
  Exch $6
!macroend

