SilentInstall silent

; The name of the NSIS install program you're creating
Name "Warne"

; The icon
Icon "figeditor.ico"

; The file that NSIS writes
OutFile "figeditor.exe"


LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR Figure Editor"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "figeditor.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "figeditor.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Structural VAR Figure Editor"

Section "Ignore"
  ; Change this exe file to the name of the exe you created
  Call GetParameters
  Pop $R8
  StrCmp $R8 '' findexe
  ;
  ; we need to replace " characters with ' characters
  ; in $R8
  ;
  Push $R8 ; variable to do replacment in
  Push '"' ; string to replace
  Push "'" ; replacement
  Call StrRep
  Pop $R8 ;result
;  StrCpy $R8 $R0
;  MessageBox MB_OK "$R8"
  findexe:
  Call GetExeFile
  Pop $R0
  Push $R0
  Call GetParent
  Pop $R0
  Push $1
  Push $2
  StrCmp $R0 "" fixr0 fix1
  fixr0:
    StrCpy $R0 $EXEDIR
  ;
  ; check if there's a space in $R0
  ;
  fix1:
    StrCpy $1 $R0
    Call SplitCommand
    Pop $3
    StrCmp $3 '-1' nospace space
  space:
    StrCpy $1 "--dir='$R0' $R8"
    StrCpy $2 '"$R0\var.exe"'
    GoTo version
  nospace:
    StrCpy $1 "--dir=$R0 $R8"
    StrCpy $2 $R0\var.exe
  version:
;  MessageBox MB_OK $2
;  Call GetWindowsVersion
;  Pop $R0
  ;
  ; if NT type system
  ;
;  MessageBox MB_OK $R0
;  StrCmp $R0 'DOS' dos
;     nsExec::Exec "cmd /C $2 -f $1"
     nsExec::Exec '$2 -f $1'
;  Goto stop
;  dos:
;     nsExec::Exec "command.com /C $2 -f $1"
;  stop:
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function GetExeFile
   Push $R0
   Push $R1
   Push $R2
   Push $R3
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      StrCpy $R0 $CMDLINE 1 $R2
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   IntOp $R2 $R2 - 2
   StrCpy $R0 $CMDLINE $R2
   StrCpy $R3 $R0 1
   StrCmp $R3 '"' next exit
   next:
      IntOp $R3 $R2 - 1
      StrCpy $R0 $R0 $R3 1
   exit:
   Pop $R2
   Pop $R1
   Exch $R0
FunctionEnd

Function GetParent
   Exch $R0 ; old $R0 is on top of stack
   Push $R1
   Push $R2
   StrCpy $R1 -1
   loop:
     StrCpy $R2 $R0 1 $R1
     StrCmp $R2 "" exit
     StrCmp $R2 "\" exit
     IntOp $R1 $R1 - 1
   Goto loop
   exit:
     StrCpy $R0 $R0 $R1
     Pop $R2
     Pop $R1
     Exch $R0 ; put $R0 on top of stack, restore $R0 to original value
 FunctionEnd


; GetWindowsVersion
 ;
 ; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
 ; Returns on top of stack
 ;
 ; Windows Version (95, 98, ME, NT x.x, 2000, XP, .NET Server)
 ; or
 ; '' (Unknown Windows Version)
 ;
 ; Usage:
 ;   Call GetWindowsVersion
 ;   Pop $R0
 ;   ; at this point $R0 is "NT 4.0" or whatnot

Function GetWindowsVersion
   Push $R0
   Push $R1
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
   StrCmp $R0 "" 0 lbl_winnt
   ; we are not NT.
   ReadRegStr $R0 HKLM SOFTWARE\Microsoft\Windows\CurrentVersion VersionNumber

   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 lbl_error

   StrCpy $R1 $R0 3

   StrCmp $R1 '4.0' lbl_win32_95
   StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98

   lbl_win32_95:
     StrCpy $R0 'DOS'
   Goto lbl_done

   lbl_win32_98:
     StrCpy $R0 'DOS'
   Goto lbl_done

   lbl_win32_ME:
     StrCpy $R0 'DOS'
   Goto lbl_done

   lbl_winnt:

     StrCpy $R1 $R0 1

     StrCmp $R1 '3' lbl_winnt_x
     StrCmp $R1 '4' lbl_winnt_x

     StrCpy $R1 $R0 3

     StrCmp $R1 '5.0' lbl_winnt_2000
     StrCmp $R1 '5.1' lbl_winnt_XP
     StrCmp $R1 '5.2' lbl_winnt_dotNET lbl_error

     lbl_winnt_x:
       StrCpy $R0 "NT $R0" 6
     Goto lbl_done

     lbl_winnt_2000:
       StrCpy $R0 '2000'
     Goto lbl_done

     lbl_winnt_XP:
       StrCpy $R0 'XP'
     Goto lbl_done

     lbl_winnt_dotNET:
       StrCpy $R0 '.NET Server'
     Goto lbl_done

   lbl_error:
     StrCpy $R0 ''
   lbl_done:
   Pop $R1
   Exch $R0
FunctionEnd

Function SplitCommand
   Push $3
   Push $R1
   StrLen $3 $1
   ;
   ; search for a space character
   ;
   loop:
      IntOp $3 $3 - 1
      StrCpy $R1 $1 1 $3
      StrCmp $R1 " " done
      StrCmp $3 '-1' done
      GoTo loop
   done:
   ;
   ; we have located the space where commands should be split
   ;
   Exch $3
FunctionEnd

Function StrRep
  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
FunctionEnd

